//-----------------------------------------------------
//	DirectX eLXg`Tv
//	Direct3D̕`֘A
//	2010.03.04 TMO
//-----------------------------------------------------

#include "stdafx.h"
#include "Graphic.h"

//uD3DFVF_TEX1v1̓eNX`̖
#define D3DFVF_2DVERTEX (D3DFVF_XYZRHW | D3DFVF_TEX1 | D3DFVF_DIFFUSE )
typedef struct _D3DVERTEX_
{   D3DVECTOR	pos;		//_̈ʒu
	float		rhw;		//1Ƃ
	D3DCOLOR    color;		//diffuse	|S̐FBʂ̕/S̃tF[hƂeNX`摜̃At@l𐧌䂷̂Ɏg
	FLOAT       tu;			//eNX`̍W
	FLOAT       tv;			//eNX`̍W

} D3DVERTEX;

CGraphic*				glbl_graphic = NULL;

LPDIRECT3D9				g_pD3D = NULL;			//D3DC^[tF[X D3DfoCX̂ɕKv
LPDIRECT3DDEVICE9		g_pD3DDevice = NULL;	//D3DfoCX `ȂǍL͈͂ŕKvɂȂB
IDirect3DVertexBuffer9* g_pVB = NULL;			//|S̃obt@

//̃R[h쐬ꂽD3DfoCX擾邽߂̂
extern LPDIRECT3DDEVICE9 GetDevice()
{
	return g_pD3DDevice;
}

//CGraphic̍쐬
CGraphic* CreateGraphic( HWND hWnd )
{
	glbl_graphic = new CGraphic();
	glbl_graphic->Create( hWnd );
	return glbl_graphic;
}

//CGraphic̎擾
CGraphic* GetGraphic() { return glbl_graphic; }

//CGraphic̉
void ReleaseGraphic()
{
	if ( glbl_graphic ) {
		glbl_graphic->Destroy();
		delete glbl_graphic;
		glbl_graphic = NULL;
	}
}


CGraphic::CGraphic()
{
	if ( g_pD3D != NULL ) {
		//CGraphic͂QȂƂɂĂB
		_ASSERT(0);
	}

	m_backColor = 0xFFFFFFFF;

	m_currDisplayMode = DisplayMode::WindowMode;

	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	
	g_pD3DDevice   = NULL;
}
CGraphic::~CGraphic()
{
	Destroy();
}

//CGraphic̍쐬
void CGraphic::Destroy()
{
	//D3DfoCX
	if( g_pD3DDevice )
	{
		g_pD3DDevice->Release();
		g_pD3DDevice = NULL;
	}

	//D3DC^[tF[X
	if( g_pD3D )
	{
		g_pD3D->Release();
		g_pD3D = NULL;
	}
}

//CGraphic̍쐬( Direct3D̏ )
bool CGraphic::Create(HWND hWnd)
{
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if ( g_pD3D == NULL ) {
		return false;
	}
	
	//D3DPRESENT_PARAMETERS\̏̂߃fBXvC[h擾
	D3DDISPLAYMODE dmode;
	ZeroMemory( &dmode, sizeof( dmode ) );
	g_pD3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT , &dmode );
	
	//foCX̏Ԃw肷
	D3DPRESENT_PARAMETERS	d3dpp;
	ZeroMemory( &d3dpp, sizeof( d3dpp ) );

	switch ( m_currDisplayMode ) {
		case DisplayMode::FullScreen:
			//tXN[
			d3dpp.Windowed         = FALSE;
			d3dpp.BackBufferWidth  = 640;
			d3dpp.BackBufferHeight = 480;
			d3dpp.BackBufferFormat = D3DFMT_X8R8G8B8;
			d3dpp.BackBufferCount  = 1;
			d3dpp.SwapEffect       = D3DSWAPEFFECT_DISCARD;
			d3dpp.FullScreen_RefreshRateInHz = 60;
			break;
		case DisplayMode::WindowMode:
			//EBhE[h
			d3dpp.Windowed			= TRUE;
			d3dpp.SwapEffect		= D3DSWAPEFFECT_DISCARD;
			d3dpp.BackBufferFormat	= dmode.Format;
			d3dpp.BackBufferCount	= 1;
			break;
	}

	//fBXvCA_v^\߂̃foCX쐬
	//`揈@ƒ_@̓n[hEFAΉłƎŝŁA@̑gݍ킹ςčēx쐬݂
	HRESULT		hr;
	D3DDEVTYPE	devtype;
	DWORD		behaviorFlags;
	for ( int c = 0; c < 4; c++ ) {
		switch ( c ) {
            case 0:
				//n[hEFAŕ`揈s
				devtype			= D3DDEVTYPE_HAL;						
				//_n[hEFAōs
				behaviorFlags	= D3DCREATE_HARDWARE_VERTEXPROCESSING;
				break;
			case 1:
				//n[hEFAŕ`揈s
				devtype			= D3DDEVTYPE_HAL;
				//_\tgEFAōs
				behaviorFlags	= D3DCREATE_SOFTWARE_VERTEXPROCESSING;
				break;
			case 2:
				//\tgEFAŕ`揈s
				devtype			= D3DDEVTYPE_REF;
				//_n[hEFAōs
				behaviorFlags	= D3DCREATE_HARDWARE_VERTEXPROCESSING;
				break;
			case 3:
				//\tgEFAŕ`揈s
				devtype			= D3DDEVTYPE_REF;						
				//_\tgEFAōs
				behaviorFlags	= D3DCREATE_SOFTWARE_VERTEXPROCESSING;
				break;
		}
		
		hr = g_pD3D->CreateDevice(
						D3DADAPTER_DEFAULT,
						devtype,
						hWnd,
						behaviorFlags,
						&d3dpp,
						&g_pD3DDevice );
		
		
		if ( FAILED(hr) ) {
			continue;
		}
		break;
	}

	if ( FAILED(hr) ) {
		//\tgEFAɂΉĂȂ
		return false;
	}

	//At@uh̐ݒ
	g_pD3DDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );
	//Lł͎vʂɓ߂Ȃ͂Ȃ̂ŁAufBOW̐ݒsB
	g_pD3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);	 
	g_pD3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA); 

	//eNX`̃At@ɁA|SFAt@Ƃĉݒ
	g_pD3DDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
	g_pD3DDevice->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE );
	g_pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE );
	g_pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
	g_pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_MODULATE );
	g_pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE );

	//|S̍쐬
	g_pD3DDevice->CreateVertexBuffer(sizeof(D3DVERTEX)*4, 0, D3DFVF_2DVERTEX, D3DPOOL_MANAGED, &g_pVB, NULL );

	return true;
}

//`OɌĂ
void CGraphic::ClearAndBegin()
{
	//ʃNA
	g_pD3DDevice->Clear( 0, NULL, D3DCLEAR_TARGET, m_backColor, 1.0f, 0 );

	//foCXɕ`Jnm点
	HRESULT hr;
	hr = g_pD3DDevice->BeginScene();
}

//`ɌĂ
void CGraphic::EndAndPresent()
{
	//foCXɕ`Im点
	g_pD3DDevice->EndScene();
	
	//ʂobNobt@ƓւB
	g_pD3DDevice->Present( NULL, NULL, NULL, NULL );
}

//F̓``Bł܂B/Ŝ̃tF[hɎg
void CGraphic::DrawColorRect( float left, float top, float right, float bottom, DWORD color )
{
	D3DVERTEX *d3dv;
	g_pVB->Lock(0 , 0 , (void**)&d3dv , 0);
	d3dv[0].pos.x = left;
	d3dv[0].pos.y = top;
	d3dv[0].pos.z = 0;
	d3dv[0].rhw = 1;
	d3dv[0].color = color;
	d3dv[0].tu = 0.0f;
	d3dv[0].tv = 0.0f;

	d3dv[1] = d3dv[0];
	d3dv[1].pos.x = right;
	d3dv[1].pos.y = top;
	d3dv[1].tu = 1.0f;
	d3dv[1].tv = 0.0f;

	d3dv[2] = d3dv[0];
	d3dv[2].pos.x = left;
	d3dv[2].pos.y = bottom;
	d3dv[2].tu = 0.0f;
	d3dv[2].tv = 1.0f;

	d3dv[3] = d3dv[0];
	d3dv[3].pos.x = right;
	d3dv[3].pos.y = bottom;
	d3dv[3].tu = 1.0f;
	d3dv[3].tv = 1.0f;

	g_pVB->Unlock();
	
	g_pD3DDevice->SetTexture(0, NULL);
	g_pD3DDevice->SetVertexShader(NULL);
	g_pD3DDevice->SetFVF( D3DFVF_2DVERTEX );
	g_pD3DDevice->SetStreamSource( 0, g_pVB, 0, sizeof(D3DVERTEX) );
	g_pD3DDevice->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2);

}

//`
void CGraphic::Draw( float left, float top, float right, float bottom, DWORD alphaColor )
{
	//wʒû܂܂ŕ`ƃ|S̋Eł킸Ȃꂪ܂B_gpĂ邽߂ƂEEEB
	//_W炷Ƃłꂢɕ`B
	left	-= 0.5f;
	top		-= 0.5f;
	right	-= 0.5f;
	bottom	-= 0.5f;

	D3DVERTEX *d3dv;
	g_pVB->Lock(0 , 0 , (void**)&d3dv , 0);
	d3dv[0].pos.x = left;
	d3dv[0].pos.y = top;
	d3dv[0].pos.z = 0;
	d3dv[0].rhw = 1;
	d3dv[0].color = alphaColor;
	d3dv[0].tu = 0.0f;
	d3dv[0].tv = 0.0f;

	d3dv[1] = d3dv[0];
	d3dv[1].pos.x = right;
	d3dv[1].pos.y = top;
	d3dv[1].tu = 1.0f;
	d3dv[1].tv = 0.0f;

	d3dv[2] = d3dv[0];
	d3dv[2].pos.x = left;
	d3dv[2].pos.y = bottom;
	d3dv[2].tu = 0.0f;
	d3dv[2].tv = 1.0f;

	d3dv[3] = d3dv[0];
	d3dv[3].pos.x = right;
	d3dv[3].pos.y = bottom;
	d3dv[3].tu = 1.0f;
	d3dv[3].tv = 1.0f;

	g_pVB->Unlock();
	
	g_pD3DDevice->SetVertexShader(NULL);
	g_pD3DDevice->SetFVF( D3DFVF_2DVERTEX );
	g_pD3DDevice->SetStreamSource( 0, g_pVB, 0, sizeof(D3DVERTEX) );
	g_pD3DDevice->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2);
}

void CGraphic::Draw( float left, float top, float right, float bottom, CTexture* texture, DWORD alphaColor )
{
	texture->SetCurrentUse();
	Draw( left, top, right, bottom, alphaColor );
}